
; ========================================================
;			
;    -- TCPAsync.asm --
;			Jay Sullivan
; ========================================================
  
; TODO:: Change old Send and Recv thread functions so they use the new
;        WM message.



.386
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE
 			
;------------------------------------------------
;               Header
;------------------------------------------------

	;----------------------------
	;     Includes
	;----------------------------
		
		include TCPAsync.inc
		
	;----------------------------
	;     Prototypes
	;----------------------------
		
		WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
;------------------------------------------------
;                .CODE
;------------------------------------------------

.CODE

	Start:
		invoke GetModuleHandle, NULL
		mov hInstance,eax
		invoke GetProcessHeap
		mov hHeap, eax
		invoke GetCommandLine
		mov CommandLine, eax
		invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
		invoke ExitProcess,eax
		

;------------------------------------------------
;	WinMain
;------------------------------------------------
WinMain PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
LOCAL hwnd:HWND
	;------------------------------------------------
	;	Windows
	;------------------------------------------------
			
		;------------------------------------------------
		;	Main Window Register
		;------------------------------------------------
		
			mov wc.cbSize, Sizeof WNDCLASSEX
			mov wc.style, CS_HREDRAW or CS_VREDRAW
			mov wc.lpfnWndProc, Offset WndProc
			mov wc.cbClsExtra,NULL
			mov wc.cbWndExtra,NULL
			mov eax,hInst
			mov wc.hInstance,eax
			mov wc.hbrBackground, COLOR_WINDOW+1
			mov wc.lpszMenuName, NULL
			mov wc.lpszClassName, Offset ClassName
			invoke LoadIcon, NULL, IDI_APPLICATION
			mov wc.hIcon,eax
			mov wc.hIconSm,0
			invoke LoadCursor, NULL, IDC_ARROW
			mov wc.hCursor,eax
			invoke RegisterClassEx, ADDR wc
		
		
		;------------------------------------------------
		;	Main Window Create
		;------------------------------------------------
		
				
			invoke CreateWindowEx, WS_EX_CLIENTEDGE, ADDR ClassName, ADDR szAppName,\
				WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN,\
				CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,\
				NULL,NULL,hInst,NULL
			mov hwnd,eax
			mov hMainWin, eax
		
			
	;------------------------------------------------
	;	WinMain Code
	;------------------------------------------------
			
		
			
		;-----------------------------
		;	Show Window
		;-----------------------------
			
			invoke ShowWindow, hwnd, SW_SHOWNORMAL
			invoke UpdateWindow, hwnd
			
		;-------------------------------------------
		; WSAStartup() -- Initialize WinSock
		;-------------------------------------------
		WinSockRetry:
			invoke WSAStartup, 0101h, Offset wsaData
			.if eax!=0
				invoke MessageBox, hwnd, $String("Winsock couldn't be initialized."), $String("WinSock Error"), MB_ABORTRETRYIGNORE or MB_ICONERROR
				.if eax==IDRETRY
					jmp WinSockRetry
				.elseif eax==IDABORT
					jmp WinSockFail
				.endif
			.endif
		;-----------------------------
		;	Message Loop
		;-----------------------------
			
			jmp @F
			StartLoop:
			  invoke TranslateMessage,ADDR msg
			  invoke DispatchMessage, ADDR msg
			@@:
			  invoke GetMessage,ADDR msg,NULL,0,0
			  test eax, eax
			  jnz StartLoop
			  
		;-------------------------------------------
		; WSACleanup() - Done
		;-------------------------------------------
			invoke WSACleanup
			
	WinSockFail:
	mov eax, msg.wParam
	ret
WinMain ENDP


;------------------------------------------------
;	WndProc
;------------------------------------------------
WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL IsConnected:DWORD

		
	;-----------------------------
	 .if uMsg==WM_TIMER
	;-----------------------------
	 	add szDotLen, 1
	 	and szDotLen, 01111b
	 	
	 	mov eax, szDotLen
	 	mov byte ptr szDots[eax], 0
		invoke SendMessage,hStatusBar, SB_SETTEXT, 3,  Offset szDots
	 	mov eax, szDotLen
	 	mov byte ptr szDots[eax], '.'
	;-----------------------------
	 .elseif uMsg==WM_SIZE
	;-----------------------------
	
		movzx eax, word ptr lParam   ; << width
		movzx ecx, word ptr lParam+2 ; << height
		sub ecx, 55+21
		shr eax, 1
		push eax
		push ecx
		invoke MoveWindow, hEditMyText, 0,55, eax, ecx, TRUE
		pop ecx
		pop eax
		invoke MoveWindow, hEditOutput, eax,55, eax, ecx, TRUE
	  	invoke MoveWindow,hStatusBar,0,0,0,0,TRUE
	;-----------------------------
	 .elseif uMsg==WM_CREATE
	;-----------------------------
		
		;------------------------------------------------
		;	Alloc
		;------------------------------------------------
			invoke HeapAlloc, hHeap, HEAP_ZERO_MEMORY, 512
			mov pBufferIPAddress, eax
			invoke HeapAlloc, hHeap, HEAP_ZERO_MEMORY, MAXGETHOSTSTRUCT
			mov pBufferHostent, eax
			
			
		 
		;------------------------------------------------
		;	buttons/edits
		;------------------------------------------------

			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCButton, $String("Connect/Send"), WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT or WS_DISABLED ,0,15,150,35,hWnd,0,hInstance,0
			mov myButtonConnect,eax
			;invoke CreateWindowEx, WS_EX_STATICEDGE , Offset szCButton, $String("Send"), WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT or WS_DISABLED ,75,15,75,35,hWnd,0,hInstance,0
			;mov myButtonSend,eax
			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCButton, $String("Disconnect"), WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT or WS_DISABLED ,150,15,100,35,hWnd,0,hInstance,0
			mov myButtonDisconnect,eax
			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCButton, $String("Load IP#"), WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT,410,15,100,35,hWnd,0,hInstance,0
			mov myButtonDNS,eax
		
			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCEdit,0, WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT or ES_NOHIDESEL or ES_AUTOHSCROLL ,510,20,180,25,hWnd,0,hInstance,0
			mov hEditIPAddress,eax
			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCEdit, Offset sendString, WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT or ES_MULTILINE or ES_NOHIDESEL or ES_AUTOVSCROLL or ES_WANTRETURN or WS_VSCROLL or WS_HSCROLL,15,55,300,500,hWnd,0,hInstance,0
			mov hEditMyText,eax
			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCEdit, NULL, WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT or ES_MULTILINE or ES_NOHIDESEL or ES_AUTOVSCROLL or ES_WANTRETURN or WS_VSCROLL or WS_HSCROLL,15,55,300,500,hWnd,0,hInstance,0
			mov hEditOutput,eax
			invoke CreateStatusWindow,WS_CHILD or WS_VISIBLE or SBS_SIZEGRIP , 0, hWnd, 444
			mov hStatusBar,eax
			invoke SendMessage,eax,SB_SETPARTS, 4, Offset StatusWidths
			
		;------------------------------------------------
		;	Get IP address
		;------------------------------------------------

			invoke SetWindowText, hEditIPAddress, Offset sDefaultIPAddress
			
		;------------------------------------------------
		;	Create Socket
		;------------------------------------------------
		
	;----------------------------------
	 .elseif uMsg==WM_WSAGETHOSTBYNAME
	;----------------------------------
	mov hAsyncRequest, 0
	
		mov eax, lParam
		shr eax, 16
		.if eax==0
			;------------------------------------------------
			; Get Fully Qualified Domain Name
			;------------------------------------------------
			mov eax, pBufferHostent
			mov ecx, [eax].hostent.h_name 
			mov pDomainName, ecx
			
			;------------------------------------------------
			; Get # IP Address
			;------------------------------------------------
			mov eax, [eax].hostent.h_list ; hostent.h_addr_list
			mov eax, [eax]  ;   *hostent.h_addr_list
			mov eax, [eax]  ;  **hostent.h_addr_list
			mov peer.sockaddr_in.sin_addr, eax
			
			;------------------------------------------------
			; Convert IP Address to a string
			;------------------------------------------------
			invoke inet_ntoa, eax
			.if eax==0
				invoke closesocket,s
				mov eax, $String("inet_ntoa error")
			.else
				invoke SendMessage,hStatusBar, SB_SETTEXT, 1,  eax
				invoke SendMessage,hStatusBar, SB_SETTEXT, 2,  pDomainName
				invoke EnableWindow, myButtonConnect, TRUE
				invoke EnableWindow, myButtonDisconnect, FALSE
				mov eax, $String("IP Loaded")
			.endif
			
		.elseif eax==WSAENETDOWN
			mov eax, $String("DNS could not be reached.")
		.elseif eax==WSAENOBUFS
			mov eax, $String("DNS Lookup buffer space ran out.")
		.elseif eax==WSAHOST_NOT_FOUND || eax==WSATRY_AGAIN
			mov eax, $String("Address not found.")
		.else
			mov eax, $String("DNS Lookup failed...somehow.")
		.endif
		
		invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  eax
				
				
		invoke KillTimer, hMainWin, IDT_TIMER1
		
	;-----------------------------
	 .elseif uMsg==WM_WSAASYNC
	;-----------------------------
			mov eax, lParam
			and eax, 0FFFFh
			
			
			;-----------------------------
			.if eax==FD_CONNECT
			;-----------------------------
				
				invoke KillTimer, hMainWin, IDT_TIMER1
				
				mov IsConnected, FALSE
				;-----------------------------
				; Check for errors
				;-----------------------------
				mov eax, lParam
				shr eax, 16
				.if eax==0 ; Success
					mov IsConnected, TRUE
					mov ecx, $String("send()")
				.elseif eax== WSAECONNREFUSED
					mov ecx, $String("Connection refused.")
				.elseif eax== WSAENETUNREACH
					mov ecx, $String("Network couldn't be reached.")
				.elseif eax== WSAETIMEDOUT
					mov ecx, $String("Connection request timed out.")
				.else
					mov ecx, $String("Connection request failed...somehow.")
				.endif
				invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  ecx
				invoke EnableWindow, myButtonDisconnect, IsConnected
				
			;-----------------------------
			.elseif eax==FD_WRITE
			;-----------------------------
				;=======================================================
				; send() -- Send bits of data until it's done
				;=======================================================
					.if SendBufferSpaceLeft!=0
					WriteAgain:
						;-------------------------------------------
						;  Calculate Current Read Spot
						;-------------------------------------------
						mov eax, pSendBuffer
						add eax, SendBufferOffset
						;-------------------------------------------
						;  Send as much as possible
						;-------------------------------------------
						invoke send, s, eax, SendBufferSpaceLeft, 0
						.if eax == SOCKET_ERROR
							invoke WSAGetLastError
							.if eax==WSAEWOULDBLOCK
								jmp DoneWriting
							.else
								invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  $String("send error")
								invoke closesocket, s
								mov SendBufferSpaceLeft, 0
								jmp DoneWriting
							.endif
						.endif
						;-------------------------------------------
						; If no space left, we're done
						;-------------------------------------------
						add SendBufferOffset, eax
						sub SendBufferSpaceLeft, eax
						jnz WriteAgain
					.endif
					
					invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  $String("recv()")
					DoneWriting:
			;-----------------------------
			.elseif eax==FD_READ
			;-----------------------------
			
				;=======================================================
				; recv() -- Get data until it's done or we get an error
				;=======================================================
				
						;-------------------------------------------
						;  Calculate Current Write Spot
						;-------------------------------------------
						mov eax, pRecvBuffer
						add eax, RecvBufferOffset
						;-------------------------------------------
						;  Receive as much as possible
						;-------------------------------------------
						invoke recv, wParam,  eax, RecvBufferSpaceLeft, 0
						.if eax == SOCKET_ERROR
							invoke SendMessage, hStatusBar,  SB_SETTEXT, 0,  $String("recv: socket error!")
							invoke closesocket, wParam
						.elseif eax==0
							invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  $String("recv: done.")
						.endif
						;-------------------------------------------
						; If received 0 bytes, we're done
						;-------------------------------------------
						add RecvBufferOffset, eax
						sub RecvBufferSpaceLeft, eax

					
				
			;-----------------------------
			.elseif eax==FD_CLOSE
			;-----------------------------
			
				invoke KillTimer, hMainWin, IDT_TIMER1
				invoke SetWindowText, hEditOutput, pRecvBuffer
				.if pSendBuffer!=0
					invoke HeapFree, hHeap, 0, pSendBuffer
					mov pSendBuffer, 0
				.endif
				.if pRecvBuffer!=0
					invoke HeapFree, hHeap, 0, pRecvBuffer
					mov pSendBuffer, 0
				.endif
				invoke EnableWindow, myButtonConnect, TRUE
				;invoke EnableWindow, myButtonSend, FALSE
				invoke EnableWindow, myButtonDisconnect, FALSE
				;-----------------------------
				; Check for errors
				;-----------------------------
				mov eax, lParam
				shr eax, 16
				.if eax==0 ; Success
					mov eax, $String("Disconnected.")
				.elseif eax==WSAECONNRESET
					mov eax, $String("Connection reset by peer.")
				.elseif eax==WSAECONNABORTED
					mov eax, $String("Connection aborted due to timeout.")
				.elseif eax==WSAENETDOWN
					mov eax, $String("Network connection Error.")
				.else
					mov eax, $String("Connection closed...um...somehow.")
				.endif
				invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  eax
				
			;-----------------------------
			.endif
			;-----------------------------
	;-----------------------------
	 .elseif uMsg==WM_COMMAND
	;-----------------------------
		
		mov eax,wParam
		;-----------------------------
		 .if ax== BN_CLICKED
		;-----------------------------
		
			mov szDotLen, 0
			mov eax, lParam
			;-----------------------------
			.if eax==myButtonDNS
			;-----------------------------
				invoke SetTimer, hWnd, IDT_TIMER1, 300, 0
				
				invoke EnableWindow, myButtonConnect, FALSE
				;invoke EnableWindow, myButtonSend, FALSE
				invoke EnableWindow, myButtonDisconnect, FALSE
				
				;------------------------------------------------
				; Clear status bar
				;------------------------------------------------
				invoke SendMessage,hStatusBar, SB_SETTEXT, 1,  0
				invoke SendMessage,hStatusBar, SB_SETTEXT, 2,  0
				
				;------------------------------------------------
				; Attempt to translate IP string to number
				;------------------------------------------------
				invoke GetWindowText, hEditIPAddress, pBufferIPAddress, 511
				invoke inet_addr, pBufferIPAddress
				mov NumberIPAddress, eax
				
				;------------------------------------------------
				; Call up DNS
				;------------------------------------------------
				.if eax==INADDR_NONE
					;------------------------------------------------
					; A domain name was typed.
					;------------------------------------------------
					invoke WSAAsyncGetHostByName, hWnd, WM_WSAGETHOSTBYNAME, pBufferIPAddress, pBufferHostent, MAXGETHOSTSTRUCT 
					mov eax, $String("gethostbyname()")
				.else
					;------------------------------------------------
					; An IP Address was typed.
					;------------------------------------------------
					invoke WSAAsyncGetHostByAddr, hWnd, WM_WSAGETHOSTBYNAME, Offset NumberIPAddress, 4, AF_INET, pBufferHostent, MAXGETHOSTSTRUCT
					mov eax, $String("gethostbyaddr()")
				.endif
				
				invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  eax
				
				
			;-----------------------------
			.elseif eax==myButtonConnect
			;-----------------------------
				invoke SetTimer, hWnd, IDT_TIMER1, 300, 0
				
	  
	  
				;-------------------------------------------
				; Zerofy
				;-------------------------------------------
				
					mov SendBufferOffset, 0
					mov RecvBufferOffset, 0
					
				;-------------------------------------------
				; Get Size of Send Buffer
				;-------------------------------------------
				
					invoke GetWindowTextLength, hEditMyText
					mov SendBufferSpaceLeft, eax
					
				;-------------------------------------------
				; Get Size of Recv Buffer
				;-------------------------------------------
				
					mov RecvBufferSpaceLeft, MAX_RECV_BUFFER_SIZE
					
				;-------------------------------------------
				; Alloc Send Buffer
				;-------------------------------------------
				
					invoke HeapAlloc, hHeap,HEAP_ZERO_MEMORY, SendBufferSpaceLeft
					mov pSendBuffer, eax
					
				;-------------------------------------------
				; Alloc Recv Buffer
				;-------------------------------------------
				
					invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY, RecvBufferSpaceLeft
					mov pRecvBuffer, eax
					
				;-------------------------------------------
				; Copy text to send buffer
				;-------------------------------------------
				
					invoke GetWindowText, hEditMyText, pSendBuffer, SendBufferSpaceLeft
					
				;-------------------------------------------
				; socket() -- Create i/o socket
				;-------------------------------------------
				invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  $String("socket()")
				invoke socket, AF_INET, SOCK_STREAM, 0
				mov s, eax
				.if eax == INVALID_SOCKET
					;-------------------------------------------
					; socket failed
					;-------------------------------------------
					invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  $String("Socket Failed.")
					invoke EnableWindow, myButtonConnect, TRUE
					invoke EnableWindow, myButtonDisconnect, FALSE
				.else
					;-------------------------------------------
					; connect() -- Wait for reply
					;-------------------------------------------
					invoke WSAAsyncSelect, s, hWnd, WM_WSAASYNC, FD_READ or FD_WRITE or FD_CONNECT or FD_CLOSE
					
					
					invoke SendMessage,hStatusBar, SB_SETTEXT, 0,  $String("connect()")
					invoke connect, s, Offset peer, Sizeof peer
					invoke EnableWindow, myButtonConnect, FALSE
					invoke EnableWindow, myButtonDisconnect, TRUE
				.endif
					
			;-----------------------------
			;.elseif eax==myButtonSend
			;-----------------------------
			;	invoke SetTimer, hWnd, IDT_TIMER1, 300, 0
			
			;	invoke EnableWindow, myButtonSend, FALSE
			
			;-----------------------------
			.elseif eax==myButtonDisconnect
			;-----------------------------
			
				invoke closesocket, s
				invoke KillTimer, hWnd, IDT_TIMER1
				.if hAsyncRequest!=0
					invoke WSACancelAsyncRequest, hAsyncRequest
					mov hAsyncRequest, 0
				.endif
				
			;-----------------------------
			.endif
			;-----------------------------
		;-----------------------------
		 .endif
		;-----------------------------
		
	;-----------------------------
	 .elseif uMsg==WM_DESTROY
	;-----------------------------
		
		invoke closesocket, s
		invoke PostQuitMessage, NULL
	;-----------------------------
	 .else
	;-----------------------------
		
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
		
	;-----------------------------
	 .endif
	;-----------------------------
	
	xor eax,eax
	ret
WndProc ENDP




End Start